package dao;

import java.time.LocalDate;

public class Conversation {
    private int idConv;
    private LocalDate dateCrea;
    private String nomConv;
    private Utilisateur createur;
    private String pwd;
    
    public Conversation(int idConv, String nomConv, Utilisateur createur, LocalDate dateCrea, String pwd) {
		this.idConv = idConv;
		this.dateCrea = dateCrea;
		this.nomConv = nomConv;
		this.createur = createur;
	}
	public int getIdConv() {
        return idConv;
    }
    public LocalDate getDateCrea() {
        return dateCrea;
    }
    public String getNomConv() {
        return nomConv;
    }
    public Utilisateur getCreateur() {
        return createur;
    }
    public void setNomConv(String nomConv) {
        this.nomConv = nomConv;
    }
    @Override
    public String toString() {
        return "Conversation [idConv=" + idConv + ", dateCrea=" + dateCrea + ", nomConv=" + nomConv + ", createur="
                + createur + ", pwd=" + pwd + "]";
    }
    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + idConv;
        result = prime * result + ((dateCrea == null) ? 0 : dateCrea.hashCode());
        result = prime * result + ((nomConv == null) ? 0 : nomConv.hashCode());
        result = prime * result + ((createur == null) ? 0 : createur.hashCode());
        result = prime * result + ((pwd == null) ? 0 : pwd.hashCode());
        return result;
    }
    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        Conversation other = (Conversation) obj;
        if (idConv != other.idConv)
            return false;
        if (dateCrea == null) {
            if (other.dateCrea != null)
                return false;
        } else if (!dateCrea.equals(other.dateCrea))
            return false;
        if (nomConv == null) {
            if (other.nomConv != null)
                return false;
        } else if (!nomConv.equals(other.nomConv))
            return false;
        if (createur == null) {
            if (other.createur != null)
                return false;
        } else if (!createur.equals(other.createur))
            return false;
        if (pwd == null) {
            if (other.pwd != null)
                return false;
        } else if (!pwd.equals(other.pwd))
            return false;
        return true;
    }

    
    }
