package dao;
import java.sql.*;
import java.time.LocalDate;
import java.util.ArrayList;
import java.util.List;

public class ConversationJdbcDao implements ConversationDao{
    UtilisateurJdbcDao jdbcUser = new UtilisateurJdbcDao();

	@Override
	public Conversation findById(int idConv) {
		try (Connection con = getCon(); Statement stmt = con.createStatement()) {
            String sql = "SELECT * FROM Conversations WHERE idConv = "+ idConv +";";
            System.err.println(sql);
            ResultSet rs = stmt.executeQuery(sql);
            rs.next();
            Conversation conversation = new Conversation(rs.getInt(1), rs.getString(2), jdbcUser.findByEmail(rs.getString(3)), rs.getDate(4).toLocalDate(), rs.getString(5));
            rs.close();
            con.close();

            return conversation;
        }catch (SQLException e) {
            System.out.println("Erreur lors de l'accès à la base de données : " + e.getMessage());
            e.printStackTrace();
        }
        return new Conversation(0, "err", new Utilisateur("err","err" , "err"),LocalDate.now(), "err");
	}

    @Override
	public List<Conversation> findByUser(String email) {
		try (Connection con = getCon(); Statement stmt = con.createStatement()) {
            String sql = "SELECT DISTINCT idConv FROM Messages WHERE utilisateur = '"+ email +"';";
            System.err.println(sql);
            ResultSet rs = stmt.executeQuery(sql);
            List<Conversation> list = new ArrayList<Conversation>();
            while(rs.next()){
                list.add(findById(rs.getInt(1)));
            }
            rs.close();
            con.close();
            return list;
        }catch (SQLException e) {
            System.out.println("Erreur lors de l'accès à la base de données : " + e.getMessage());
            e.printStackTrace();
        }
        return new ArrayList<Conversation>();
	}

	@Override
	public List<Message> findAllMessages(int idConv) {
		try (Connection con = getCon(); Statement stmt = con.createStatement()) {
            String sql = "SELECT * FROM Messages WHERE idConv = "+idConv+";";
            System.err.println(sql);
            ResultSet rs = stmt.executeQuery(sql);
            List<Message> list = new ArrayList<Message>();
            while(rs.next()){
                list.add(new Message(rs.getInt(1), rs.getInt(2), rs.getDate(3).toLocalDate(), rs.getTime(4).toLocalTime(), rs.getString(5), jdbcUser.findByEmail(rs.getString(6))));
            }
            rs.close();
            con.close();
            return list;
        }catch (SQLException e) {
            System.out.println("Erreur lors de l'accès à la base de données : " + e.getMessage());
            e.printStackTrace();
        }
        return new ArrayList<Message>();
	}

	@Override
	public List<Utilisateur> findAllUtilisateurs(int idConv) {
		try (Connection con = getCon(); Statement stmt = con.createStatement()) {
            String sql = "SELECT DISTINCT utilisateur FROM Message WHERE idConv = "+idConv+";";
            System.err.println(sql);
            ResultSet rs = stmt.executeQuery(sql);
            List<Utilisateur> list = new ArrayList<Utilisateur>();
            int i= 1;
            while(rs.next()){
                list.add(jdbcUser.findByEmail(rs.getString(i)));
                i++;
            }
            rs.close();
            con.close();
            return list;
        }catch (SQLException e) {
            System.out.println("Erreur lors de l'accès à la base de données : " + e.getMessage());
            e.printStackTrace();
        }
        return new ArrayList<Utilisateur>();
	}

	@Override
	public int createConversation(String nomConv, Utilisateur createur, String pwd) {
        try (Connection con = getCon()) {
            // Utilisation de PreparedStatement avec Statement.RETURN_GENERATED_KEYS pour récupérer l'ID généré
            String sql = "INSERT INTO Conversations(nomConv, createur, pwd) VALUES('"+nomConv+"', '"+createur.getEmail()+"', MD5('"+pwd+"'));";
            
            // Préparer la requête pour insertion avec des paramètres
            try (PreparedStatement pstmt = con.prepareStatement(sql, Statement.RETURN_GENERATED_KEYS)) {
                // Exécuter la requête d'insertion
                pstmt.executeUpdate();
                
                // Récupérer les clés générées
                try (ResultSet rs = pstmt.getGeneratedKeys()) {
                    if (rs.next()) {
                        // Récupérer l'ID généré
                        int res = rs.getInt(1); // Le premier champ dans ResultSet est l'ID auto-généré
                        return res;
                    }
                }
            }
        } catch (SQLException e) {
            System.out.println("Erreur lors de l'accès à la base de données : " + e.getMessage());
            e.printStackTrace();
        }
        return 0; // Retourner 0 en cas d'erreur
    }
    

	@Override
	public boolean deleteConversation(int idConv) {
		try (Connection con = getCon(); Statement stmt = con.createStatement()) {
            String sql = "DELETE FROM Conversations CASCADE WHERE idConv = "+idConv+";";
            System.err.println(sql);
            ResultSet rs = stmt.executeQuery(sql);
            rs.next();
            rs.close();
            con.close();
            return true;
        }catch (SQLException e) {
            System.out.println("Erreur lors de l'accès à la base de données : " + e.getMessage());
            e.printStackTrace();
        }
        return false;
	}

    private Connection getCon() {
        
        try {

            String driver = "org.postgresql.Driver";
            String url = "jdbc:postgresql://psqlserv/but2";
            String nom = "alexandredehaineetu";
            String mdp = "moi";

            Class.forName(driver);
            return DriverManager.getConnection(url, nom, mdp);

        } catch (Exception e) {
            System.out.println(e.getMessage());
        }

        return null;

    }

    @Override
    public boolean goodPwd(int idConv, String pwd) {
        try (Connection con = getCon(); Statement stmt = con.createStatement()) {
            String sql = "SELECT * FROM Conversations WHERE idConv = "+ idConv +" AND pwd = MD5('"+pwd+"');";
            System.err.println(sql);
            ResultSet rs = stmt.executeQuery(sql);
            if(rs.next()){
                rs.close();
                con.close();
                return true;
            }
            rs.close();
            con.close();
            return false;
        }catch (SQLException e) {
            System.out.println("Erreur lors de l'accès à la base de données : " + e.getMessage());
            e.printStackTrace();
        }
        return false;
    }
    
}
